<template>
  <div class="block-form ui form">
    <div
      v-if="isFormShow || actionType === 'edit'"
      class="subtitle"
    >Ваша организация</div>
    <div class="two fields">
      <div
        class="field"
        :class="{invalid: validation.hasError('inn')}">
        <label>ИНН организации</label>
        <div class="block-input-btn">
          <div class="ui input">
            <input
              type="text"
              v-model="inn"
              maxlength="12"
              @input="resetFieldsInn"
            >
          </div>
          <button
            class="ui button blue small"
            :disabled="validation.hasError('inn') || inn === '' || loading.inn"
            @click="checkInn"
            :class="{loading : loading.inn}"
          >
            Проверить
          </button>
        </div>
        <div
          class="error message"
          v-if="validation.hasError('inn')">
          {{ validation.firstError('inn') }}
        </div>
      </div>
      <div
        v-if="isFormShow || actionType === 'edit'"
        class="field">
        <label>Наименование организации</label>
        <div class="ui input ">
          <input
            type="text"
            disabled
            v-model="organization.shortOrganizationName">
        </div>

        <div
          class="error message"
          v-if="organization.stateStatus === 'LIQUIDATED'">
          Ликвидирована {{ organization.liquidationDate | dateFormatRu }} г.
        </div>
      </div>
    </div>

    <div
      v-if="isFormShow || actionType === 'edit'"
      class="fluid">
      <div class="fields">
        <div class="field fluid">
          <label>Полное наименование организации</label>
          <div class="ui input">
            <input
              type="text"
              disabled
              v-model="organization.fullOrganizationName">
          </div>
        </div>
      </div>

      <div class="two fields">
        <div class="field">
          <label>Должность руководителя</label>
          <div class="ui input">
            <input
              type="text"
              disabled
              v-model="organization.managerPost">
          </div>
        </div>
        <div class="field">
          <label>ФИО руководителя</label>
          <div class="ui input">
            <input
              type="text"
              disabled
              v-model="organization.managerName">
          </div>
        </div>
      </div>

      <div class="two fields">
        <div class="field">
          <label>КПП</label>
          <div class="ui input">
            <input
              type="text"
              disabled
              v-model="organization.kpp">
          </div>
        </div>
        <div class="field">
          <label>ОГРН</label>
          <div class="ui input">
            <input
              type="text"
              disabled
              v-model="organization.ogrn">
          </div>
        </div>
      </div>

      <div class="two fields">
        <div class="field">
          <label>Юридический адрес</label>
          <div class="ui input">
            <input
              type="text"
              v-model="legalAddress">
          </div>
        </div>
        <div class="field">
          <label>Фактический адрес</label>
          <div class="ui input">
            <input
              type="text"
              v-model="factAddress">
          </div>
        </div>
      </div>

      <div class="two fields">
        <div class="field">
          <label>Почтовый адрес</label>
          <div class="ui input">
            <input
              type="text"
              v-model="postAddress">
          </div>
        </div>
        <div class="field"/>
      </div>
      <div class="subtitle details">Реквизиты</div>

      <div class="two fields">
        <div
          class="field"
          :class="{invalid: validation.hasError('bik')}">
          <label>БИК</label>
          <div class="block-input-btn">
            <div class="ui input">
              <input
                v-model="bik"
                type="text"
                maxlength="9"
                @input="resetFieldsBik"
              >
            </div>
            <button
              class="ui button blue small"
              :disabled="validation.hasError('bik') || loading.bik"
              @click="checkBik"
              :class="{loading : loading.bik}"
            >Проверить
            </button>
          </div>
          <div
            class="error message"
            v-if="validation.hasError('bik') || bikError">
            {{ validation.firstError('bik') }}
            <template v-if="bikError && !validation.firstError('bik')">Недопустимое значение БИК</template>
          </div>
        </div>
        <div class="field">
          <label>Р/C</label>
          <div class="ui input">
            <input
              type="text"
              v-model="bank.bankAccount"
            >
          </div>
        </div>
      </div>

      <div class="two fields">
        <div class="field">
          <label>Банк</label>
          <div class="ui input">
            <input
              type="text"
              disabled
              v-model="bank.bankName"
            >
          </div>
        </div>
        <div class="field">
          <label>K/С</label>
          <div class="ui input">
            <input
              type="text"
              disabled
              v-model="bank.correspondentAccount"
            >
          </div>
        </div>
      </div>

      <div class="fields">
        <div class="field fluid">
          <div class="ui checkbox">
            <input
              type="checkbox"
              name="show-info"
              v-model="showForCustomer"
              id="show-info">
            <label for="show-info">Отображать информацию о вашей организации покупателям</label>
          </div>
        </div>
      </div>

    </div>

    <div
      v-if="isFormShow || actionType === 'edit'"
      class="block-btn">
      <button
        type="submit"
        :disabled="disabled || loading.submit"
        @click="submit"
        class="ui button yellow btn-add-organization"
        :class="{loading : loading.submit}">
        <span v-if="actionType === 'new'">Создать&nbsp;</span>
        <span v-if="actionType === 'edit'">Сохранить&nbsp;</span>
        <span>организацию</span>
      </button>
    </div>

    <div slot="line-modal">
      <exit-save
        @save="saveViaModal"
        :link="goToPath"
        :has-errors="disabled"
        v-model="modals.exitSave"/>
    </div>

  </div>
</template>
<script>
import SimpleVueValidation from 'simple-vue-validator';
import watcherForProps from '~/assets/js/mixins/watcherForProps';
import ExitSave from '~/components/redesign/cabinet/modal/exit-save';
import { createNamespacedHelpers } from 'vuex';
import { find, get } from 'lodash-es';
import dayjs from 'dayjs';
import 'dayjs/locale/ru';

import { SHOW } from '~/assets/js/store/infoModal/action-types';
import { REFRESH_USER } from '~/assets/js/store/user/action-types';

dayjs.locale('ru');

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
const STORE_USER = createNamespacedHelpers('user');

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    digit: 'Недопустимое значение',
    email: 'Недопустимое значение',
  },
});

export default {
  name: 'FormOrganization',
  components: {
    ExitSave,
  },
  filters: {
    dateFormatRu(value) {
      if (!value) {
        return null;
      }
      value *= 1000;
      return dayjs(value).format('DD MMMM YYYY');
    },
  },
  mixins: [
    watcherForProps(['inn', 'legalAddress', 'postAddress', 'factAddress', 'bank', 'showForCustomer'], { deep: true }),
  ],
  props: {
    actionType: {
      type: String,
      default: '',
    },
  },
  data() {
    const org = find(this.$store.state.user.auth.organization.legals, ['id', this.$route.params.id]);
    return {
      modals: {
        exitSave: false,
      },
      goToPath: '',
      showForCustomer: get(org, 'showToCustomers', false),
      checkResult: this.actionType === 'edit',
      innError: null,
      bikError: false,
      legalAddress: get(org, 'legalAddress', ''),
      postAddress: get(org, 'postAddress', ''),
      factAddress: get(org, 'factAddress', ''),
      inn: get(org, 'inn', ''),
      bik: get(org, 'bik', ''),
      loading: {
        inn: false,
        bik: false,
        submit: false,
      },
      bank: {
        correspondentAccount: get(org, 'correspondentAccount', ''),
        bankName: get(org, 'bankCity', ''),
        bankAccount: get(org, 'bankAccount', ''),
      },
      organization: {
        shortOrganizationName: get(org, 'name', ''),
        fullOrganizationName: get(org, 'fullName', ''),
        inn: get(org, 'inn', ''),
        kpp: get(org, 'kpp', ''),
        ogrn: get(org, 'ogrn', ''),
        managerName: get(org, 'directorName', ''),
        managerPost: get(org, 'directorPost', ''),
        stateStatus: get(org, 'stateStatus', ''),
        liquidationDate: get(org, 'liquidationDate', ''),
      },
      error: false,
      isFormShow: false,
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    disabled() {
      return !(this.validation.errors.length === 0 && this.inn !== '' && this.checkResult);
    },
  },
  validators: {
    inn(value) {
      return SimpleVueValidator
        .value(value)
        .digit()
        .custom(() => (value.length !== 10 && value.length !== 12) && 'Недопустимое значение ИНН');
    },
    bik(value) {
      return SimpleVueValidator
        .value(value)
        .digit().custom(() => (value.length !== 0 && value.length !== 9) && 'Недопустимое значение БИК');
    },
  },
  mounted() {
    document.addEventListener('mousedown', this.onLeaveBeforeSave);
  },
  destroyed() {
    document.removeEventListener('mousedown', this.onLeaveBeforeSave);
  },
  methods: {
    ...STORE_USER.mapActions({
      refreshUser: REFRESH_USER,
    }),
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    showTechSupportInfo(message) {
      this.showInfo({
        text: message,
        buttonVisibility: true,
        buttonText: 'Написать в тех.поддержку',
        buttonUrl: '/about-us/contacts',
      });
    },
    showTempErrorInfo() {
      this.showInfo({
        text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
        buttonVisibility: false,
      });
    },
    exitSaveAction() {
      this.modals.exitSave = true;
    },
    onLeaveBeforeSave(e) {
      const link = e.target.closest('a');

      if (!link) {
        return;
      }
      if (link.target === '_blank') {
        return;
      }
      if (this.isPropChanged) {
        this.exitSaveAction();
        this.goToPath = link.pathname;
      }
    },
    send() {
      this.loading.submit = true;
      let url = 'create';

      if (this.actionType === 'edit') {
        url = 'update';
      }

      return this.$axios.$post(`/_main/organization/${url}`, {
        id: Number(this.$route.params.id),
        shortOrganizationName: this.organization.shortOrganizationName,
        fullOrganizationName: this.organization.fullOrganizationName,
        inn: this.inn,
        kpp: this.organization.kpp,
        ogrn: this.organization.ogrn,
        managerName: this.organization.managerName,
        managerPost: this.organization.managerPost,
        bik: this.bik,
        correspondentAccount: this.bank.correspondentAccount,
        bankAccount: this.bank.bankAccount,
        bankName: this.bank.bankName,
        showForCustomer: this.showForCustomer,
        legalAddress: this.legalAddress,
        factAddress: this.factAddress,
        postAddress: this.postAddress,
      }).then(async (res) => {
        await this.refreshUser();
        return res.data;
      }).catch((e) => {
        if (get(e, 'response.status', null) === 400) {
          this.showTechSupportInfo(get(e, 'response.data.message', ''));
        } else {
          this.showTempErrorInfo();
          console.error(e);
        }
        return false;
      }).finally(() => {
        this.loading.submit = false;
      });
    },
    async saveViaModal() {
      if (this.hasErrors) {
        this.modals.exitSave = false;
      } else {
        const sendingResult = await this.send();
        if (sendingResult) {
          // @todo раскомментить, когда будут готовы все разделы на фронтапе
          // this.$router.push({ path: this.goToPath });
          window.location.href = this.goToPath;
          this.goToPath = '';
        }
      }
    },
    async submit() {
      if (this.hasErrors) {
        this.modals.exitSave = false;
      } else {
        const sendingResult = await this.send();
        if (sendingResult) {
          window.location.href = '/cabinet/wrench/organization-info';
        }

        // @todo раскомментить, когда будут готовы разделы на фронтапе
        // auth.isOrganization
        //   ? this.$router.push({ path: '/cabinet/wrench/organization-info' })
        //   : this.$router.push({ path: '/cabinet/wrench/notification-setup' });
        this.modals.exitSave = false;
      }
    },
    validate() {
      return this.$validate().then(success => success && { inn: this.inn });
    },
    checkInn() {
      this.loading.inn = true;
      return this.$axios.$get('/_main/organization/getByInn', {
        params: {
          requisiteId: this.$route.params.id,
          inn: this.inn,
        },
      })
        .then((res) => {
          this.organization = res.data;
          this.isFormShow = true;
          this.checkResult = true;
        }).catch((e) => {
          this.organization = {
            shortOrganizationName: '',
            fullOrganizationName: '',
            inn: '',
            kpp: '',
            ogrn: '',
            managerName: '',
            managerPost: '',
            stateStatus: '',
            liquidationDate: '',
          };
          this.isFormShow = false;
          this.checkResult = false;

          if (get(e, 'response.status', null) === 400) {
            this.showTechSupportInfo(get(e, 'response.data.message', ''));
          } else {
            this.showTempErrorInfo();
            console.error(e);
          }
        }).finally(() => {
          this.loading.inn = false;
        });
    },
    resetFieldsInn() {
      this.checkResult = false;
      this.organization = {
        shortOrganizationName: '',
        fullOrganizationName: '',
        inn: '',
        kpp: '',
        ogrn: '',
        managerName: '',
        managerPost: '',
        stateStatus: '',
        liquidationDate: '',
      };
    },
    resetFieldsBik() {
      this.bikError = false;
      this.checkResult = false;
      this.bank = {
        correspondentAccount: '',
        bankName: '',
        rs: '',
      };
    },
    checkBik() {
      this.loading.bik = true;
      return this.$axios.$get('/_main/organization/getBankInfo', {
        params: { bik: this.bik },
      })
        .then((res) => {
          this.bank.correspondentAccount = res.data.correspondentAccount;
          this.bank.bankName = res.data.bankName;
          this.bikError = false;
          this.checkResult = true;
        }).catch((e) => {
          console.error(e);
          this.bikError = true;
          this.checkResult = false;
        }).finally(() => {
          this.loading.bik = false;
        });
    },
  },
};
</script>

<style scoped lang="scss">
  .question {
    @media screen and (max-width: 980px) {
      display: none;
    }
    @media screen and (min-width: 981px) {
      position: relative;
      display: inline-flex;
      > .button {
        display: inline-flex;
        justify-content: center;
        align-items: center;
        width: 1rem;
        height: 1rem;
        background: transparent;
        border: 1px solid #9badb9;
        border-radius: 50%;
        outline: 0;
        cursor: pointer;
        &:before {
          display: inline-flex;
          content: "?";
          font-size: 0.75rem;
          font-weight: normal;
          line-height: 1;
          color: #4272a4;
        }
      }
    }
  }

  .subtitle {
    display: block;
    line-height: 1.3;
    font-weight: 500;
    padding: 0 0 1rem 0;
    font-size: 0.875rem;
    &.details {
      padding-top: 1rem;
    }
  }

  .block-btn {
    display: block;
    width: 100%;
    padding: 1.5rem 0;
    .btn-add-organization {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      margin: 0;
      font-size: 0.875rem;
      + .btn-add-organization {
        margin-left: 1.5rem;
      }
      .svg-fill {
        height: 1.25rem;
        width: auto;
        margin: 0 0.5rem 0 -0.5rem;
        fill: #272727;
      }
    }
  }

  .block-form {
    display: flex;
    flex-flow: row wrap;
    justify-content: flex-start;
    align-items: stretch;
    width: 40rem;
    padding-top: 1.5rem;
    .fields,
    .fluid {
      width: 100%;
    }
    .field {
      &.invalid {
        input {
          border-top-right-radius: 0;
          border-right: none;
          border-bottom-right-radius: 0;
        }
      }
    }
    .block-input-btn {
      display: flex;
      flex-flow: row nowrap;
      justify-content: space-between;
      align-items: stretch;
      .ui.input {
        flex: 0 1 auto;
        input {
          border-right-color: transparent;
        }
      }
      .ui.button {
        position: relative;
        max-height: none;
        margin-left: -0.05rem;
        margin-right: 0;
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
      }
      @media screen and (max-width: 479px) {
        flex-flow: column nowrap;
        .ui.button {
          font-size: 0.875rem;
          margin: -0.05rem 0 0 0;
          border-top-left-radius: 0;
          border-top-right-radius: 0;
          border-bottom-left-radius: 0.25rem;
          max-height: none;
        }
        .ui.input {
          width: 100%;
        }
      }
      @media (min-width: 480px) and (max-width: 980px) {
        .ui.button {
          flex: 1 0 8rem;
          font-size: 0.875rem;
        }
        .ui.input {
          max-width: calc(100% - 8rem);
        }
      }
      @media screen and (min-width: 981px) {
        .ui.button {
          flex: 1 0 7.5rem;
        }
        .ui.input {
          max-width: calc(100% - 7.5rem);
        }
      }
    }
  }

</style>
